C Tp.f
C
C VIS-5D function to calculate PERTURBATION temperature (Tp)

C ==============================================================================

      INTEGER FUNCTION USERFUNC( OUTGRID, OUTNL, OUTLOWLEV,
     *                           INGRID, NR, NC, NL, LOWLEV, MAXNL,
     *                           NVARS, NAMES,
     *                           DATE, TIME,
     *                           PROJECTION, PROJ_ARGS,
     *                           VERTICAL, VERT_ARGS )
C ARGUMENTS:
      implicit none
      INTEGER NVARS
      INTEGER NR, NC, NL(NVARS), LOWLEV(NVARS), MAXNL
      REAL OUTGRID(NR,NC,MAXNL)
      INTEGER OUTNL, OUTLOWLEV
      REAL INGRID(NR,NC,MAXNL,NVARS)
      CHARACTER*8 NAMES(NVARS)
      INTEGER DATE, TIME
      INTEGER PROJECTION
      REAL PROJ_ARGS(*)
      INTEGER VERTICAL
      REAL VERT_ARGS(*)

C LOCAL VARS:
      integer var, ir, ic, il
      integer it, itm  

C ==============================================================================
      
C Specify number of levels in OUTGRID
      OUTNL = MAXNL
      OUTLOWLEV = 0
      
C Find the T and Tm variables (TOTAL and MEAN fields)
      it = -1
      itm = -1
      do var=1,nvars
        if (names(var) .eq. 'T') it = var
        if (names(var) .eq. 'Tm') itm = var        
      end do

C If T or Tm not found, return error 1
      if ( it.eq.-1 .or. itm.eq.-1 ) then
        print *, 
     $  "Couldn't find T or Tm vars!"
        userfunc = 1
        return
      endif

C ==============================================================================

C OUTPUT OF PERTURBATION TEMPERATURE Tp (=T-Tm) 

      print*,
     $'Output of PERTURBATION temperature Tp (C)'
      DO 9999 ir=1,nr
      DO 9999 ic=1,nc
      DO 9999 il=1,maxnl
        outgrid(ir,ic,il)=ingrid(ir,ic,il,it)-
     $                    ingrid(ir,ic,il,itm)
9999  CONTINUE     

C ==============================================================================
               
      USERFUNC = 0
      RETURN
      END

C ==============================================================================
